/*
 *  pack.c -- pack TypedOutputStream.
 *
 *  20-feb-2001 / gmt
 *
 *  Reads whitespace-separated tokens from stdin and writes as a
 *  TypedOutputStream to stdout.  Tokens having the form of integers
 *  are written as such; all others are written as strings.
 *  Note in particular that floating-point values are not handled.
 */

#include <stdio.h>
#include "tstream.h"

#define MAXSTR 1000

int main(int argc, char *argv[]) {
    char buf[MAXSTR], c;
    long v;

    while (scanf(" %s", buf) == 1) {
	if (sscanf(buf, "%ld%c", &v, &c) == 1)
	    writeInteger(stdout, v);
	else
	    writeString(stdout, buf);
    }

    return 0;
}
