/*
 * tokPort.h --
 *
 *	This header files describes the facilities of the token client
 *	that will need porting.
 *
 * $Id: tokPort.h,v 1.3 2001/07/03 21:46:26 gmt Exp $
 */

#ifndef _TOKPORT
#define _TOKPORT

#include <pthread.h>

/*
 * Typedefs:
 */
typedef pthread_mutex_t	TokMutex;
typedef pthread_cond_t TokCond;
typedef struct TokNetwork *TokNetwork;


/*
 * Prototypes:
 */

/* abort.c */

void		TokAbort(char *message);
void		TokPerror(char *message);

/* TokAlloc.c */

void *		TokAlloc(size_t nbytes);
char *		TokSalloc(char *s);
void *		TokZalloc(size_t nbytes);
void *		TokRealloc(void *p, size_t nbytes);
void		TokFree(void *p);

/* netw.c */

TokNetwork	TokInitNetw(char *names[], int ports[], int n);
void		TokTermNetw(TokNetwork net);
char *		TokHostPort(TokNetwork net);
void		TokSend(TokNetwork net, int dest, void *buf, int len);
int		TokRecv(TokNetwork net, void *buf, int len);

/* thread.c */

void		TokSpawn(void *(*threadProc)(void *), void *arg);

void		TokInitMutex(TokMutex *m);
void		TokLockMutex(TokMutex *m);
void		TokUnlockMutex(TokMutex *m);
void		TokDestroyMutex(TokMutex *m);

void		TokInitCond(TokCond *cv);
void		TokWaitCond(TokCond *cv, TokMutex *m);
void		TokSignalCond(TokCond *cv);
void		TokDestroyCond(TokCond *cv);

#endif /* _TOKPORT */
