#!/bin/sh
#
#  Test the token server and client code by feeding a script of commands
#  to the Broker utility class.

COMMANDS=tBroker.cmd
CONFIG=tBroker.cfg

#  kill server process after normal or abnormal exit
trap 'X=$?; kill $SERVER; exit $X' 0 1 2 15

#  trace commands; abort on any error
set -x -e

#  configure 
CLASSPATH=../../bin/topovista.jar
export CLASSPATH

#  disable JITter, for better traceback in case of abort
JAVA_COMPILER=
export JAVA_COMPILER

#  start server in background, remembering its PID
java topovista.toksvc.Server $CONFIG 0 &
SERVER=$!

#  run client from script, saving output
java topovista.toksvc.Broker $CONFIG $COMMANDS >tBroker.out

# edit and sort the output to remove variable portions
sed '/Client/s/([^)]*)/(...)/' <tBroker.out | LC_ALL=C sort >tBroker.srt

#  check output against what was expected
cmp tBroker.std tBroker.srt
