#!/bin/sh
#
#  Test the C client library by feeding a script of commands
#  to the tkbroker program

TKSRC=../../src/tokenlib
COMMANDS=tCBroker.cmd
CONFIG=tCBroker.cfg

#  kill the server process after a normal or abnormal exit
trap 'X=$?; kill $SERVER; exit $X' 0 1 2 15

#  trace commands; abort on any error
set -x -e

#  start the server in the background, remembering its PID
java -classpath ../../bin/topovista.jar topovista.toksvc.Server $CONFIG 0 &
SERVER=$!

#  give the server a chance to open ports
sleep 2

#  run the standalone tester
../components/utest $CONFIG >utest.out

#  check its output
cmp utest.std utest.out

#  run tkbroker program from script, saving output
$TKSRC/tkbroker $CONFIG <$COMMANDS >tCBroker.out

#  check output against what was expected
cmp tCBroker.std tCBroker.out
