//  tCircBuf.java -- tests the CircularBuffer class


import java.util.*;
import topovista.toksvc.*;

class tCircBuf {


public static void main(String args[]) {

    dump(new CircularBuffer());
    dump(new CircularBuffer(17).add("hello").add("goodbye"));

    CircularBuffer b = new CircularBuffer(3);
    int n = 1;
    for (int i = 0; i < 10; i++) {
	b.add("A" + i);
    }
    dump(b);
    dump(b.clear());
    dump(b.add("B1").add("B2"));
}


static void dump(CircularBuffer b) {
    System.out.println();
    System.out.println(b + "  size=" + b.size() + " cap=" + b.capacity());
    System.out.print("enum:    ");
    for (Enumeration e = b.elements(); e.hasMoreElements(); ) {
	System.out.print(" " + e.nextElement());
    }
    System.out.println();
    for (int i = -1; i <= 5; i++) {
	bdump(b, i);
    }
}


static void bdump(CircularBuffer b, int n) {
    Object[] a;
    if (n < 0) {
	System.out.print("bdump *: ");
	a = b.toArray();
    } else {
	System.out.print("bdump " + n + ": ");
	a = new String[n];
	a = b.toArray(a);
    }
    for (int i = 0; i < a.length; i++) {
	String s = (String) a[i];
	System.out.print(" " + (s == null ? "-" : s));
    }

    System.out.println();
}


} // class tCircBuf
