//  tQueue.java -- tests the Queue class
//
//  When run with any argument, suppresses clock portion of output
//  for greater reproducibility of output (for automated testing).
//  May give irreproducible results on busy systems.
//
//  Fails sometimes on Solaris using "Solaris_JDK_1.2.1_03" Java
//  (Thread.InterruptedException is not caught as it should be)
//  but passes using Solaris "1.3beta-O" Java.


import java.util.*;
import topovista.toksvc.*;

class tQueue {


public static void main(final String args[]) throws Exception {

    final Queue q = new Queue();
    System.out.println("begin");
    q.put("111");		// load queue when nobody waiting
    q.put("222");

    // start consumer thread
    Thread c = new Thread() {
	public void run() {
	    for (;;) {
		Object val = q.get();
		System.out.println(val);
	    }
	}
    };
    c.setDaemon(true);
    c.start();

    q.put("333");		// send to queue when consumer hungry
    Thread.yield();
    q.put("444");
    q.put("555");
    try {
	Thread.sleep(20);
    } catch (Exception e) {
    }
    q.put("666");
    q.put("777");

    try {
	Thread.sleep(100);	// let consumer daemon empty the queue
    } catch (Exception e) {
    }
    System.out.println("done");
}


} // class tQueue
