package topovista.explorer;

/**
 *  Implements a bounded random walk that does not stray
 *  into non-data cells.
 */

class BoundedWalk extends Explorer {



BoundedWalk() {
    super('b', "bounded walk");
}



public Cell nextLoc(World w, Cell curr) {
    Cell[] list = w.neighbors(curr);
    shuffle(list);
    for (int i = 0; i < 4; i++) {
	if (list[i].hasdata) {
	    return list[i];
	}
    }
    // no neighbor has data; revert to first choice
    return list[0];
}



} // class BoundedWalk
