//  LeadMessage.java -- proclaiming leadership


package topovista.toksvc;

import java.net.*;



/**
 *  A LeadMessage serves as the Council leader's heartbeat.
 */
class LeadMessage extends CouncilMessage {



final static int MTYPE = 4;	// type code for this Message class



/**
 *  Constructor for synthesizing a new message.
 *  The "term" and "msgnum" fields are omitted during construction,
 *  but are filled in by Leader.broadcast().
 */
LeadMessage() {
    super(MTYPE, 0, 0);
}



/**
 *  Constructor for synthesizing a subclass of LeadMessage.
 */
LeadMessage(int type) {
    super(type, 0, 0);
}



/**
 *  Constructs a LeadMessage by reading from a Pickle.
 */
LeadMessage(Pickle p) {
    super(p);
}



}  // class LeadMessage
