//  Queue.java -- a simple buffer for message-passing synchronization



package topovista.toksvc;

import java.util.*;



/**
 *  Queue provides a simple buffer for message-passing
 *  synchronization.
 */

public class Queue {


    private Vector v = new Vector();



/**
 *  Adds an object to the end of the queue.
 */
public synchronized void put(Object o) {
    v.addElement(o);
    this.notifyAll();
}



/**
 *  Removes the next object from the queue, waiting if necessary.
 */
public synchronized Object get() {
    while (v.isEmpty()) {
	try {
	    this.wait();
	} catch (InterruptedException e) {
	}
    }
    Object o = v.firstElement();
    v.removeElementAt(0);
    return o;
}



/**
 *  Returns the length of the queue.
 */
public int size() {		// not synchronized: no need
    return v.size();
}



}  // class Queue
