//  RevokeMessage.java -- requesting release of a token by a client


package topovista.toksvc;

import java.net.*;



/**
 *  A RevokeMessage asks a client to return a token
 *  that it currently has assigned.
 */
class RevokeMessage extends Message {

    String name;			// token name



final static int MTYPE = 23;	// type code for this message class



/**
 *  Constructor for synthesizing a new message.
 */
RevokeMessage(String name) {
    super(MTYPE);
    this.name = name;
}



/**
 *  Adds the encoding of this object to a Pickle.
 */
Pickle pickle(Pickle p) {
    super.pickle(p);
    p.put(name);
    return p;
}



/**
 *  Constructs a RevokeMessage by reading from a Pickle.
 */
RevokeMessage(Pickle p) {
    super(p);
    name = p.getString();
}



/**
 *  Returns a string representation of this message.
 */
public String toString() {
    return super.toString() + "(" + name + ")";
}



}  // class RevokeMessage
