//  tMsgs.java -- a simple test of the council framework for sending messages


package topovista.toksvc;	// has to be: uses non-public interfaces


class tMsgs {


static String[] servers;


public static void main(String args[])
throws Exception {

    Configuration cf = new Configuration("tMsgs.cfg");
    servers = cf.getArray("server");
    for (int i = 0; i < servers.length; i++) {
	System.out.println(i + "a. port=" + servers[i]);
	final int n = i;
	new Thread() {
	    public void run() {
		serve(n);
	    }
	}.start();
    }
}


static void serve(final int n) {

    Receiver r = new Receiver() {
	public void incoming(Message m) {
	    System.out.println("on " + n + " rcv " + m +
		"\t<" + new String(((DataMessage)m).data) + ">");
	}
    };

    try {
	Council c = new Council(servers, n);
	byte[] b0 = new byte[0];
	byte[] bs = "abcdefghijklmnopqrst".substring(n, 2 * n + 1).getBytes();
	System.out.println(n + "b. serving ID=" + new String(bs));
	System.out.println(n + "c. listening");
	c.listen(r);
	System.out.println(n + "d. sleeping");
	Thread.sleep(1000);
	System.out.println(n + "e. sending");
	c.send(new DataMessage(bs), (n + 1) % servers.length);
	c.send(new DataMessage(b0), (n + 2) % servers.length);
	c.send(new DataMessage(bs), (n + 3) % servers.length);
	c.send(new DataMessage(bs),
	    (n - 1 + servers.length) % servers.length);
	c.send(new DataMessage(bs), n);		// to self
	c.broadcast(new DataMessage(bs));		// broadcast
	System.out.println(n + "f. sleeping");
	Thread.sleep(100);
	System.out.println(n + "g. exiting");
    } catch (Exception e) {
	Util.abort("tMsgs", e);
    };
}


} // class tMsgs
