package topovista.tvsucker;

import java.io.*;
import java.net.*;



/**
 *  The HTTP reader fetches tiles via HTTP using java.net facilities.
 */

class HTTPReader extends Reader {

    private URL base;		// URL of directory containing tiles


/**
 *  Constructs an HTTPReader for fetching tiles from the
 *  base directory given by the URL.
 */
public HTTPReader(String url) throws Exception {
    base = new URL(url);
}



/**
 *  Loads a tile (synchronously) from a URL.
 */
public void fetch(Tile t) throws Exception {
    t.req();
    URL u = new URL(base, t.getName());
    InputStream in = new BufferedInputStream(u.openStream());
    t.resp();
    loadFile(in, t);
    in.close();
    t.done();
}



/**
 *  Returns a string representation of this reader.
 */
public String toString() {
    return "HTTPReader(" + base + ")";
}



} // class HTTPReader
