package topovista.tvsucker;

import java.io.*;



/**
 *  Navigates through a list of tiles read from a file.
 */
class ListNav extends Navigator {

    private BufferedReader rdr;


/*
 *  Constructs a list navigator.
 */
public ListNav(InputStream ins) throws Exception {
    rdr = new BufferedReader(new InputStreamReader(ins));
}



/*
 *  Returns the Tile specified by the next line from the input file.
 */
public synchronized Tile nextTile() throws Exception {
    String s = rdr.readLine();
    if (s == null) {
	return null;
    } else {
	return new Tile(s);
    }
}



/**
 *  Returns a string representation of this navigator.
 */
public String toString() {
    return "ListNav(" + rdr + ")";
}



} // class ListNav
